
/* Space harrier floor :

GTR 2020  for CX 
*/
uniform sampler2D Texture;

uniform float timer;
uniform float speed;
uniform float p1;
uniform float p2;
uniform float p3;
uniform float p4;


vec2 scale(vec2 pos, float size, vec2 center)
{
 	return vec2((pos-center)*size);   
}


 
void shader(){

	//convert clip position to valid tex coords
 
	 //vec2 uv = (b3d_ClipPosition.st/b3d_ClipPosition.w)*0.5+0.5;
 	 vec2 uv = b3d_Texcoord0.xy;

	 vec4 bColor = vec4(1.0,0.6,0.4,1.0);
	 vec4 tColor = vec4(0.0,0.6,0.4,1.0);
	 
	 
	 uv=uv*2.-1.0;
          vec2 q = vec2((uv.x)/(uv.y/uv.x),uv.y);
 
			
	vec3 project =  vec3(uv.x,   -0.60, uv.y);
		
	float lookY = p3;
    
	q = project.xy/ (project.z+lookY) + vec2(p2, -timer*speed) ; // xx
			  
	 
    vec2 z =  vec2(scale(q,(abs(1.0)*(p1/2.)),vec2(0.,0.)));
    
    vec4 tex = texture2D(Texture,fract(z));
	// Fog factor
	  tex *= smoothstep(-0.2, 0.4, abs( uv.y + lookY));
     
	  if (uv.y >-lookY  )  b3d_FragColor = vec4(tex ); 
	  else 
	  
	
	
	
	//write output
	b3d_FragColor= mix(vec4(bColor), vec4(tColor), tex.a );
}
